Flow processing을 위한 시스템

설명은 주로 TCP/IP 를 기준으로 설명하였지만
딱히 네트워크만을 위한 시스템은 아니다.

#Data, Signal, Flow, Context
모든 데이터에는 플로우 정보가 붙는다.
각 플로우에는 종류별로 identifier가 있다.
플로우 종류 간에는 dependency 및, layer가 있다.
하나의 플로우 layer에는 하나의 플로우만 존재할 수 있다.
하나의 데이터에는 각 layer별로 여러 플로우가 있을 수 있다.
(ex. packet has Eth,IP,TCP flow info.
However only single "TCP" flow can exist for a data).

"시그널에는 플로우가 존재하지 않는다." - 유일한 차이점.

##Modifier의 정의

###Const
변하지 않는 값이다.

###Static Const
컴파일 타임에 미리 값을 알 수 있다.
상수(1,2,3), 문자열("ㅁㄴㅇㄹ"), 열거형, 등이 포함된다.

###Readable
값을 읽을 수 있다.
하지만 읽는 시점에 따라서 추후에 값이 바뀔 수 있다.

###Writable
값을 변경할 수 있다.
값을 읽으려면 Readable을 따로 지정해주어야 한다.

###Referable
자신의 값을 refer 해서 연산에 사용할 수 있다.
하지만 그 값을 직접 읽는 것은 불가능하다.

###Positive
a + b = c에서
a < c 가 항상 성립하는 값 b를 지칭한다.

###Negative
a + b = c에서
a > c 가 항사 성립하는 값 b를 지칭한다.

###Auto-Increment
증가만 하는 값이다.
값을 직접 읽는 것은 불가능하며 변경 또한 내부적으로 일어난다.
수동으로 값을 변경하는것이 불가능하다.
a = a + b에서
a가 Referable | Writable,
b가 Positive인 특수 경우에서 a를 지칭한다.

###Auto-Decrement
위의 반대가 되는 값이다.
아마 문서에서 사용이 되지 않으면 없어질 수도 있다.
a = a + b에서
a가 Referable | Writable,
b가 Negative인 특수 경우에서 a를 지칭한다.

##Context
{key:value} 로 정의된 Map이다.
Key는 const이어야 한다.
value는 여러 가지 값이 될 수 있다.
편의상 TCP::OPTION 식으로 namespace를 정의할 수 있으나
현재로서는 "TCP::OPTION" 의 하나의 key로 취급된다.
Key는 반드시 Const이어야 한다.
Value는 반드시 Const Readable, Readable, Readable|Writable일 수 있다.
이는 Key에 대하여 미리 정의되어야 한다.

##Data
Processing의 단위가 되는 데이터이다.
패킷은 대표적인 데이터이다.
Data의 내부는 직접 변경될 수 없다.

###Range
데이터의 부분을 칭한다.
Range는 (start, length)의 튜플로 정의된다.
* start는 Offset의 타입을 가진다.
* length는 Length의 타입을 가진다.
* Offset은 total ordering이 가능하다.
* Offset + Length = Offset이 되는 + 연산이 존재한다.
* Offset간에는 + 연산이 정의되지 않는다.

Offset에 대하여 다음 연산이 정의된다.
* <, > : Total ordering을 위한 연산자. 따로 정의해야 한다.
* 각 연산자는 asymmetric 해야 한다.
* a < b 이면 b > a 이다.
* 각 연산자는 transitive 하다.
* == 기본적으로 a > b, a < b 로 정의되나 따로 정할 수 있다.
* == 는 equivalence class를 이룬다.

###Part
Access := (Data X Range) -> Part
인 타입 Part와 Relation Access를 정의할 수 있다.
A(D1, R1) = P1, A(D2, R2) = P2 일 때
D1 != D2 implies independent(P1, P2) 이다.
A(D1, R1) = P1, A(D1, R2) = P2 일 때
R1 intersect R2 = (Empty) implies independent(P1, P2).
R1 intersect R2 = (Not Empty) implies dependent(P1, P2).

Part는 다음의 타입을 가질 수 있다.
* Const
* Readable
* Writable
* Referable
Part는 항상 Positive하다. (unsigned data 로 취급).

##Flow, Signal
Context와 Data의 특수한 경우를 각각 Flow와 Signal이라 칭한다. 

###Flow
Data는 Context에 대하여 reference를 가질 수 있다.
이러한 Context는 특별히 Flow라고 불린다.
Flow가 아닌 Context의 데이터는 Data handler에서 직접 변경할 수 없다.

###Signal
Context를 가지지 않는 데이터를 Signal이라고 부른다.

###요약
Data: Context가 있으면 그냥 Data, Context가 없으면 특별히 Signal.
Context: Data가 없으면 그냥 Context, Data가 있으면 Flow.
* (Data = y, Context = y) => (Data, Flow)
* (Data = y, Context = n) => (Signal, None)
* (Data = n, Context = y) => (None, Context)
* (Data = n, Context = n) => (None, None)

##Flow Class (FClass)
Flow의 가능한 Key들을 모아둔 것을 Flow Class라 한다.
FClass(F1) == C1 IFF
C1 includes Keyset(F1).

Flow의 정의에 다음을 추가한다.
모든 Flow는 적어도 하나의 FC에 속한다.

모든 Flow Class들은 Disjoint하다.
이 문장은 다음을 imply한다.
"하나의 Flow는 하나의 Flow Class에 밖에 속할 수 없다."

##FClass의 Level
데이터는 여러 Flow를 Refer할 수 있다.
그리고 Flow Class들에는 hierarchy가 존재한다.

###Level
Data D, FClass FC에 대하여 Relation Level을 정의한다.

* Level := (Data X Flow Class) -> Non-zero Integer
* Level(D, FC1) == X, X > 0 이면 Level(D, FC2) == (X-1) 인 F2가 존재한다.
(Continuity)
* Level(D, FC1) < Level(D, FC2) implies 
(

FC1에 속하는 Flow F1_1, F1_2, FC2의 F2_1, F2_2에 대하여
F1_1 != F1_2 implies F2_1 != F2_2.
역은 성립하지 않는다. 

)
* 하나의 데이터 D에 대하여 "현재" 연결된 Flow들의 Level은 겹치지 않는다.
(중간에 Flow가 생성되었다가 사라질 수는 있다.)
(TODO: 좀 더 깔끔하게 설명...)

이는 다음을 의미한다:
Level이 올라감에 따라 Flow는 갈라지기만 할 뿐, 합쳐지지는 않는다.
F1->F2_1, F1->F2_2식으로 갈라질 수는 있지만
F1_1->F2, F1_2->F2는 일어나지 않는다.

예를 들면 IP context는 여러 개의 TCP context로 분리될 수 있지만
여러 IP context가 하나의 TCP context로 합쳐질 수는 없다.

###Parent, Child, Ancestor, Decendant
같은 데이터 D에 대하여 다음을 정의한다.

* Level(D, FC1) < Level(D, FC2) := FC1 is Ancestor of FC2
* Level(D, FC1) > Level(D, FC2) := FC1 is Decendant of FC2
* 차이가 1인 경우를 각각 Parent, Child라 부른다.

###예시

FClass Ethernet, IP, IPSec, TCP가 있는 상황에서 각 FC의 레벨을 표시하면

Ethernet(0)->IP(1)->IPSec(2), 그리고 IPSec이 다 까진 다음 사라지고나면

Ethernet(0)->IP(1)->TCP(2) 가 된다.

어느 순간이든지 level은 0,1,2,로 유지된다.
하지만 Level 2에 속하는 Flow Class는 IPSec, TCP 두 가지가 있다.

#Module

모듈은 FPS에서 Processing을 담당하는 가장 작은 단위이다.
모듈은 데이터와 관련 Flow 정보를 받아서 처리를 하게 된다.

##Port

모든 모듈은 다른 모듈과 통신할 수 있는 port를 정의한다.
Port는 반드시 Static Const형식이어야 한다.
Port는 Inport와 Output 두 가지가 있다.
Inport와 Outport는 서로 호환되지 않는다.

모든 모듈은 다음 virtual 함수를 implement해야 한다.
* receive_data(data, in_port)
* receive_signal(signal, in_port)
모든 모듈은 다음 함수를 상속받아서 사용할 수 있다. 변경은 불가능하다.
* send_data(data, out_port)
* send_signal(data, out_port)

각 Port는 다음과 같이 이어질 수 있다.
* inport->outport
* outport->inport

모든 Inport는 참조하는 외부 Flow의 Key를 정의하여야 사용할 수 있다.
모든 Outport는 제공하는 Flow key들을 정의하여야 외부 참조가 가능하다.

각 모듈은 Flow와는 관계 없는 자신만의 Context를 정의해서 가지고 있을 수 있다.
Context는 오직 그 모듈 내부에서만 사용된다.

모듈엔 다음과 같은 종류가 있다.

##Standalone
다음 virtual function을 implement할 수 있다.
* module_init: 초기화 데이터를 받을 수 있다.

오직 Standalone 모듈만이 Native 함수와 링크를 할 수 있다.
Standalone 모듈은 Flow를 갖지 않을 수 있다.

##Straight
Flow level에 변화가 없는 모듈이다.
추가적인 virtual function을 갖지 않는다.

###Commutative and Associative (CAStraight)
Straight 모듈의 receive_data 부분이 위 조건을 만족하면
그 모듈을 CAS 모듈이라 부른다.
이 모듈은 Flow에 Access할 때 반드시 Referable이나 Const Field만을 참조해야 한다.
(진짜 이거면 충분한가?)

##Splitter
Flow level을 새로 만들 수 있는 모듈이다.
L1->L2 (L2 = L1 + 1)로 만드는 Splitter 모듈은
L1의 모든 필드를 읽기만 할 수 있다.
L2의 필드를 쓸 수 있다.
Splitter는 어떠한 Flow을 생성하는지 명시하여야 한다
(IP to TCP splitter 이런식으로).

기존 데이터에 Flow를 추가하는 것이 아닌 새로운 Flow를 만

##Merger
Flow level을 삭제할 수 있는 모듈이다.
어느 Flow를 삭제하는지 명시하여야 한다.
(IP Merger 는 IP context를 모두 삭제한다.)
Merger는 하위 Flow를 자동적으로 제거한다.
Merger는 삭제하려는 Flow의 Decendant들에는 접근할 수 없다.

#Signal
Signal은 Context와 상관없기 때문에 어느 방향으로든 진행할 수 있다.
다만 하나의 Signal pipe (out->in)은 단방향 통신이기 때문에
송신용, 수신용 Signal pipe를 따로 만들어 주어야 한다.

//여기까지 하면 데이터 수신까지는 아무 문제 없을 것 같은데
//응답 패킷을 쏘는 부분이 문제네요...


#고려해야 할 시나리오
TCP proxy (transparent/not)
TCP
IP frag
vpn
ipsec
